/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha6 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_openstack/openstack/v1alpha6"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeOpenStackClusterTemplates implements OpenStackClusterTemplateInterface
type FakeOpenStackClusterTemplates struct {
	Fake *FakeInfrastructureV1alpha6
	ns   string
}

var openstackclustertemplatesResource = schema.GroupVersionResource{Group: "infrastructure.cluster.x-k8s.io", Version: "v1alpha6", Resource: "openstackclustertemplates"}

var openstackclustertemplatesKind = schema.GroupVersionKind{Group: "infrastructure.cluster.x-k8s.io", Version: "v1alpha6", Kind: "OpenStackClusterTemplate"}

// Get takes name of the openStackClusterTemplate, and returns the corresponding openStackClusterTemplate object, and an error if there is any.
func (c *FakeOpenStackClusterTemplates) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha6.OpenStackClusterTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(openstackclustertemplatesResource, c.ns, name), &v1alpha6.OpenStackClusterTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha6.OpenStackClusterTemplate), err
}

// List takes label and field selectors, and returns the list of OpenStackClusterTemplates that match those selectors.
func (c *FakeOpenStackClusterTemplates) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha6.OpenStackClusterTemplateList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(openstackclustertemplatesResource, openstackclustertemplatesKind, c.ns, opts), &v1alpha6.OpenStackClusterTemplateList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha6.OpenStackClusterTemplateList{ListMeta: obj.(*v1alpha6.OpenStackClusterTemplateList).ListMeta}
	for _, item := range obj.(*v1alpha6.OpenStackClusterTemplateList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested openStackClusterTemplates.
func (c *FakeOpenStackClusterTemplates) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(openstackclustertemplatesResource, c.ns, opts))

}

// Create takes the representation of a openStackClusterTemplate and creates it.  Returns the server's representation of the openStackClusterTemplate, and an error, if there is any.
func (c *FakeOpenStackClusterTemplates) Create(ctx context.Context, openStackClusterTemplate *v1alpha6.OpenStackClusterTemplate, opts v1.CreateOptions) (result *v1alpha6.OpenStackClusterTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(openstackclustertemplatesResource, c.ns, openStackClusterTemplate), &v1alpha6.OpenStackClusterTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha6.OpenStackClusterTemplate), err
}

// Update takes the representation of a openStackClusterTemplate and updates it. Returns the server's representation of the openStackClusterTemplate, and an error, if there is any.
func (c *FakeOpenStackClusterTemplates) Update(ctx context.Context, openStackClusterTemplate *v1alpha6.OpenStackClusterTemplate, opts v1.UpdateOptions) (result *v1alpha6.OpenStackClusterTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(openstackclustertemplatesResource, c.ns, openStackClusterTemplate), &v1alpha6.OpenStackClusterTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha6.OpenStackClusterTemplate), err
}

// Delete takes name of the openStackClusterTemplate and deletes it. Returns an error if one occurs.
func (c *FakeOpenStackClusterTemplates) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(openstackclustertemplatesResource, c.ns, name, opts), &v1alpha6.OpenStackClusterTemplate{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeOpenStackClusterTemplates) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(openstackclustertemplatesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha6.OpenStackClusterTemplateList{})
	return err
}

// Patch applies the patch and returns the patched openStackClusterTemplate.
func (c *FakeOpenStackClusterTemplates) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha6.OpenStackClusterTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(openstackclustertemplatesResource, c.ns, name, pt, data, subresources...), &v1alpha6.OpenStackClusterTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha6.OpenStackClusterTemplate), err
}
